rev-parse: --show-cdup
[git/fastimport.git] / git-clone.sh
blobbfc6c2d79ff3d6c50fd397c36ee04693695ad814
1 #!/bin/sh
3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
5 #
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
9 unset CDPATH
11 usage() {
12 echo >&2 "Usage: $0 [-l [-s]] [-q] [-u <upload-pack>] [-o <name>] [-n] <repo> [<dir>]"
13 exit 1
16 get_repo_base() {
17 (cd "$1" && (cd .git ; pwd)) 2> /dev/null
20 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
21 curl_extra_args="-k"
24 http_fetch () {
25 # $1 = Remote, $2 = Local
26 curl -nsfL $curl_extra_args "$1" >"$2"
29 clone_dumb_http () {
30 # $1 - remote, $2 - local
31 cd "$2" &&
32 clone_tmp='.git/clone-tmp' &&
33 mkdir -p "$clone_tmp" || exit 1
34 http_fetch "$1/info/refs" "$clone_tmp/refs" &&
35 http_fetch "$1/objects/info/packs" "$clone_tmp/packs" || {
36 echo >&2 "Cannot get remote repository information.
37 Perhaps git-update-server-info needs to be run there?"
38 exit 1;
40 while read type name
42 case "$type" in
43 P) ;;
44 *) continue ;;
45 esac &&
47 idx=`expr "$name" : '\(.*\)\.pack'`.idx
48 http_fetch "$1/objects/pack/$name" ".git/objects/pack/$name" &&
49 http_fetch "$1/objects/pack/$idx" ".git/objects/pack/$idx" &&
50 git-verify-pack ".git/objects/pack/$idx" || exit 1
51 done <"$clone_tmp/packs"
53 while read sha1 refname
55 name=`expr "$refname" : 'refs/\(.*\)'` &&
56 case "$name" in
57 *^*) ;;
59 git-http-fetch -v -a -w "$name" "$name" "$1/" || exit 1
60 esac
61 done <"$clone_tmp/refs"
62 rm -fr "$clone_tmp"
65 quiet=
66 use_local=no
67 local_shared=no
68 no_checkout=
69 upload_pack=
70 origin=origin
71 while
72 case "$#,$1" in
73 0,*) break ;;
74 *,-n) no_checkout=yes ;;
75 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
76 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
77 local_shared=yes; use_local=yes ;;
78 *,-q|*,--quiet) quiet=-q ;;
79 1,-o) usage;;
80 *,-o)
81 git-check-ref-format "$2" || {
82 echo >&2 "'$2' is not suitable for a branch name"
83 exit 1
85 origin="$2"; shift
87 1,-u|1,--upload-pack) usage ;;
88 *,-u|*,--upload-pack)
89 shift
90 upload_pack="--exec=$1" ;;
91 *,-*) usage ;;
92 *) break ;;
93 esac
95 shift
96 done
98 # Turn the source into an absolute path if
99 # it is local
100 repo="$1"
101 local=no
102 if base=$(get_repo_base "$repo"); then
103 repo="$base"
104 local=yes
107 dir="$2"
108 # Try using "humanish" part of source repo if user didn't specify one
109 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*/||g')
110 [ -e "$dir" ] && echo "$dir already exists." && usage
111 mkdir -p "$dir" &&
112 D=$(
113 (cd "$dir" && git-init-db && pwd)
114 ) &&
115 test -d "$D" || usage
117 # We do local magic only when the user tells us to.
118 case "$local,$use_local" in
119 yes,yes)
120 ( cd "$repo/objects" ) || {
121 echo >&2 "-l flag seen but $repo is not local."
122 exit 1
125 case "$local_shared" in
127 # See if we can hardlink and drop "l" if not.
128 sample_file=$(cd "$repo" && \
129 find objects -type f -print | sed -e 1q)
131 # objects directory should not be empty since we are cloning!
132 test -f "$repo/$sample_file" || exit
135 if ln "$repo/$sample_file" "$D/.git/objects/sample" 2>/dev/null
136 then
138 fi &&
139 rm -f "$D/.git/objects/sample" &&
140 cd "$repo" &&
141 find objects -depth -print | cpio -puamd$l "$D/.git/" || exit 1
143 yes)
144 mkdir -p "$D/.git/objects/info"
146 test -f "$repo/objects/info/alternates" &&
147 cat "$repo/objects/info/alternates";
148 echo "$repo/objects"
149 } >"$D/.git/objects/info/alternates"
151 esac
153 # Make a duplicate of refs and HEAD pointer
154 HEAD=
155 if test -f "$repo/HEAD"
156 then
157 HEAD=HEAD
159 (cd "$repo" && tar cf - refs $HEAD) |
160 (cd "$D/.git" && tar xf -) || exit 1
163 case "$repo" in
164 rsync://*)
165 rsync $quiet -av --ignore-existing \
166 --exclude info "$repo/objects/" "$D/.git/objects/" &&
167 rsync $quiet -av --ignore-existing \
168 --exclude info "$repo/refs/" "$D/.git/refs/" || exit
170 # Look at objects/info/alternates for rsync -- http will
171 # support it natively and git native ones will do it on the
172 # remote end. Not having that file is not a crime.
173 rsync -q "$repo/objects/info/alternates" \
174 "$D/.git/TMP_ALT" 2>/dev/null ||
175 rm -f "$D/.git/TMP_ALT"
176 if test -f "$D/.git/TMP_ALT"
177 then
178 ( cd "$D" &&
179 . git-parse-remote &&
180 resolve_alternates "$repo" <"./.git/TMP_ALT" ) |
181 while read alt
183 case "$alt" in 'bad alternate: '*) die "$alt";; esac
184 case "$quiet" in
185 '') echo >&2 "Getting alternate: $alt" ;;
186 esac
187 rsync $quiet -av --ignore-existing \
188 --exclude info "$alt" "$D/.git/objects" || exit
189 done
190 rm -f "$D/.git/TMP_ALT"
193 http://*)
194 clone_dumb_http "$repo" "$D"
197 cd "$D" && case "$upload_pack" in
198 '') git-clone-pack $quiet "$repo" ;;
199 *) git-clone-pack $quiet "$upload_pack" "$repo" ;;
200 esac || {
201 echo >&2 "clone-pack from '$repo' failed."
202 exit 1
205 esac
207 esac
209 cd "$D" || exit
211 if test -f ".git/HEAD"
212 then
213 head_points_at=`git-symbolic-ref HEAD`
214 case "$head_points_at" in
215 refs/heads/*)
216 head_points_at=`expr "$head_points_at" : 'refs/heads/\(.*\)'`
217 mkdir -p .git/remotes &&
218 echo >.git/remotes/origin \
219 "URL: $repo
220 Pull: $head_points_at:$origin" &&
221 git-update-ref "refs/heads/$origin" $(git-rev-parse HEAD) &&
222 find .git/refs/heads -type f -print |
223 while read ref
225 head=`expr "$ref" : '.git/refs/heads/\(.*\)'` &&
226 test "$head_points_at" = "$head" ||
227 test "$origin" = "$head" ||
228 echo "Pull: ${head}:${head}"
229 done >>.git/remotes/origin
230 esac
232 case "$no_checkout" in
234 git checkout
235 esac